#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program  
# C/C++ Compiler Used: Borland C++ Builder 4.0
# Produced By: Doug Gaer
# File Creation Date: 08/05/1999 
# Date Last Modified: 09/02/1999
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#
# --------------------------------------------------------------- 
!if !$d(BCB)
BCB = $(MAKEDIR)\..
!endif

# Define a name for the executable
PROJECT = testprog

# Setup additional paths for includes and source code
CDATE_PATH = ../../src/
EHANDLER_PATH = ../../src/
DTYPES_PATH = ../../src/

ADD_INC_PATHS = -I../../include

# Alloaction method used to reclaim deleted blocks
DEF_VB_ALLOC = /D__RECLAIM_BEST_FIT__ 
#DEF_VB_ALLOC = /D__RECLAIM_FIRST_FIT__ 

# Setup define macros
DEFMACS = -D__BCC_BUILDER_40__ /D__USE_CPP_IOSTREAM__ #/DCPP_EXCEPTIONS

# Define macros for compiler and linker
CC = bcc32
CPP = bcc32
LINKER = ilink32

# BCC 32 flags need to build console applications
SYSDEFINES = _NO_VCL
CFLAG1 = -I$(BCB)\include -Od -w -Tkh30000 -r- -a8 -k -y -v -vi- -c -tWM -tWC \
-D$(SYSDEFINES);$(USERDEFINES) 
LFLAG1 = -L$(BCB)\lib;$(DEBUGLIBPATH) -ap -Tpe -x -Gn -v

# Define compiler and linker flags macros
CFLAGS= $(CFLAG1) $(ADD_INC_PATHS) $(DEFMACS)
COMPILE_ONLY = /c
LFLAGS = $(LFLAG1)

# Build dependency rules
# ===============================================================
EHANDLER_DEP = ../../include/ehandler.h

UINT16_DEP = ../../include/dtypes.h ../../include/ehandler.h \
	../../include/uint16.h

CDATE_DEP = ../../include/dtypes.h ../../include/ehandler.h \
	../../include/uint16.h ../../include/cdate.h 

TESTPROG_DEP = ../../include/dtypes.h ../../include/ehandler.h \
		../../include/uint16.h ../../include/cdate.h 
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT).exe

ehandler.obj:	$(EHANDLER_PATH)ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(EHANDLER_PATH)ehandler.cpp

testprog.obj:	testprog.cpp $(TESTPROG_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testprog.cpp

uint16.obj:	$(DTYPES_PATH)uint16.cpp $(UINT16_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(DTYPES_PATH)uint16.cpp

cdate.obj:    $(CDATE_PATH)cdate.cpp $(CDATE_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(CDATE_PATH)cdate.cpp

# Make the executable
OBJS = ehandler.obj uint16.obj cdate.obj testprog.obj 
 
# BCC 32 libs needed to build console applications
ALLOBJ = c0x32.obj $(OBJS)
ALLRES = $(RESFILES)
ALLLIB = $(LIBFILES) import32.lib cw32mt.lib

$(PROJECT).exe:	$(OBJS)
	$(LINKER) @&&!
	$(LFLAGS) +
	$(ALLOBJ), +
	$(PROJECT),, +
	$(ALLLIB), +
	$(DEFFILE), +
	$(ALLRES)
!
# ===============================================================

# Remove OBJS, debug files, and executable after running nmake 
# ===============================================================
clean:
	@echo Removing all .tds files from working directory...
	if exist *.tds del *.tds 

	@echo Removing all .ils files from working directory...
	if exist *.ils del *.ils 

	@echo Removing all .ilf files from working directory...
	if exist *.ilf del *.ilf 

	@echo Removing all .ilc files from working directory...
	if exist *.ilc del *.ilc 

	@echo Removing all .ild files from working directory...
	if exist *.ild del *.ild 

	@echo Removing all .map files from working directory...
	if exist *.map del *.map 

	@echo Removing all .OBJ files from working directory...
	if exist *.obj del *.obj 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT).exe del $(PROJECT).exe 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################


