// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: as2ps.h 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer 
// File Creation Date: 12/17/1997  
// Date Last Modified: 09/02/1999
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

ASCII to PostScript converter program.  

Changes:
================================================================
03/31/1999: - Modified code to expand wildcard characters used
in command-line arguments.
Changed by: Doug Gaer

================================================================
09/02/1999 - Modified iostream functions to work with Borland
C++ builder 4.0
Changed by: Doug 
*/
// ----------------------------------------------------------- //   
#ifndef __ASPS_HPP__
#define __ASPS_HPP__

#include "pscript.h"

// Postscript driver version number and program name
const double ASPSVersionNumber = 1031.201;
const char *ProgramName = "as2ps";

// AS2PS program functions
void HelpMessage(const char *program_name, const double version_number);
PostScriptDrv ProcessArgs(int argc, char *argv[]);
int GenOutputFileName(char *extension);
void DocumentSetup(PostScriptDrv &psdrv);

#endif  // __ASPS_HPP__ //
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
