#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Make file for the utility program
# C/C++ Compiler Used: Borland C++ Builder 4.0
# Produced By: Doug Gaer
# File Creation Date: 08/05/1999 
# Date Last Modified: 09/20/1999
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
#
# NOTE: None of the Borland compilers will expand wildcard characters
# used in command-line arguments unless compiled & linked with the
# wildargs.obj module.
#
# All the UNIX compliers will expand wildcard characters by default.
#
# --------------------------------------------------------------- 
!if !$d(BCB)
BCB = $(MAKEDIR)\..
!endif

# Define a name for the executable
PROJECT = ffind

# Installation directory for the application and config files
INSTALL_DIR = ..\..\bin

# Macro for path separator
PATHSEP=/

# Setup additional paths for includes and source code
FFIND_PATH = .
USTRING_PATH = ../../src
STRUTIL_PATH = ../../src
DLLIST_PATH = ../../src

ADD_INC_PATHS = -I../../include

# Additional compile macros
DEFMACS = -D__BCC_BUILDER_40__ -D__DOS__

# Define macros for compiler and linker
CC = bcc32
CPP = bcc32
LINKER = ilink32

# BCC 32 flags need to build console applications
SYSDEFINES = _NO_VCL
CFLAG1 = -I$(BCB)\include -Od -w -Tkh30000 -r- -a8 -k -y -v -vi- -c -tWM -tWC \
-D$(SYSDEFINES);$(USERDEFINES) 
LFLAG1 = -L$(BCB)\lib;$(DEBUGLIBPATH) -ap -Tpe -x -Gn -v

# Define compiler and linker flags macros
CFLAGS= $(CFLAG1) $(ADD_INC_PATHS) $(DEFMACS)
COMPILE_ONLY = /c
LFLAGS = $(LFLAG1)

# Build dependency rules
# ===============================================================
USTRING_DEP = ../../include/ustring.h

STRUTIL_DEP = ../../include/strutil.h

FFIND_DEP = ../../include/ustring.h \
	../../include/strutil.h

DLLISTB_DEP = ../../include/dllistb.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT).exe

ustring.obj:	$(USTRING_PATH)$(PATHSEP)ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) \
	$(USTRING_PATH)$(PATHSEP)ustring.cpp

strutil.obj:	$(STRUTIL_PATH)$(PATHSEP)strutil.cpp $(STRUTIL_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) \
	$(STRUTIL_PATH)$(PATHSEP)strutil.cpp

ffind.obj:	$(FFIND_PATH)$(PATHSEP)ffind.cpp $(FFIND_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) \
	$(FFIND_PATH)$(PATHSEP)ffind.cpp

dllistb.obj:	$(DLLIST_PATH)$(PATHSEP)dllistb.cpp $(DLLIST_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) \
	$(DLLIST_PATH)$(PATHSEP)dllistb.cpp

# Make the executable
OBJECTS = ustring.obj strutil.obj ffind.obj dllistb.obj
 
# BCC 32 libs needed to build console applications
ALLOBJ = c0x32.obj $(OBJECTS) wildargs.obj
ALLRES = $(RESFILES)
ALLLIB = $(LIBFILES) import32.lib cw32mt.lib

$(PROJECT).exe:	$(OBJECTS)
	$(LINKER) @&&!
	$(LFLAGS) +
	$(ALLOBJ), +
	$(PROJECT),, +
	$(ALLLIB), +
	$(DEFFILE), +
	$(ALLRES)
!
# ===============================================================

# Remove OBJS, debug files, and executable after running nmake 
# ===============================================================
clean:
	@echo Removing all .tds files from working directory...
	if exist *.tds del *.tds 

	@echo Removing all .ils files from working directory...
	if exist *.ils del *.ils 

	@echo Removing all .ilf files from working directory...
	if exist *.ilf del *.ilf 

	@echo Removing all .ilc files from working directory...
	if exist *.ilc del *.ilc 

	@echo Removing all .ild files from working directory...
	if exist *.ild del *.ild 

	@echo Removing all .map files from working directory...
	if exist *.map del *.map 

	@echo Removing all .OBJ files from working directory...
	if exist *.obj del *.obj 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT).exe del $(PROJECT).exe 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################


