#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program  
# C/C++ Compiler Used: Borland C++ Builder 4.0
# Produced By: Doug Gaer
# File Creation Date: 08/05/1999 
# Date Last Modified: 09/02/1999
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
# Syntax is: BCC32 [ options ] file[s] * = default; -x- = turn switch x off
# -3    * 80386 Instructions        -4      80486 Instructions
# -5      Pentium Instructions      -6      Pentium Pro Instructions
# -Ax     Disable extensions        -B      Compile via assembly
# -C      Allow nested comments     -Dxxx   Define macro
# -Exxx   Alternate Assembler name  -Hxxx   Use pre-compiled headers
# -Ixxx   Include files directory   -K      Default char is unsigned
# -Lxxx   Libraries directory       -M      Generate link map
# -N      Check stack overflow      -Ox     Optimizations
# -P      Force C++ compile         -R      Produce browser info
# -RT   * Generate RTTI             -S      Produce assembly output
# -Txxx   Set assembler option      -Uxxx   Undefine macro
# -Vx     Virtual table control     -X      Suppress autodep. output
# -aN     Align on N bytes          -b    * Treat enums as integers
# -c      Compile only              -d      Merge duplicate strings
# -exxx   Executable file name      -fxx    Floating point options
# -gN     Stop after N warnings     -iN     Max. identifier length
# -jN     Stop after N errors       -k    * Standard stack frame
# -lx     Set linker option         -nxxx   Output file directory
# -oxxx   Object file name          -p      Pascal calls
#                                   -tWxxx  Create Windows app
# -u    * Underscores on externs    -v      Source level debugging
# -wxxx   Warning control           -xxxx   Exception handling
# -y      Produce line number info  -zxxx   Set segment name##
#
#
# Turbo Incremental Link 4.00 Copyright (c) 1997, 1999 Inprise Corporation
# Syntax: ILINK32 objfiles, exefile, mapfile, libfiles, deffile, resfiles
# @xxxx indicates use response file xxxx
# -m      Map file with publics     -x       No map
# -s      Detailed segment map      -L       Specify library search paths
# -M      Map with mangled names    -j       Specify object search paths
# -t      Show time spent in link   -v       Full symbolic debug information
# -Enn    Max number of errors      -Gi      Generate import library
# -b:xxxx Specify image base addr   -H:xxxx  Specify app heap reserve size
# -wxxx   Warning control           -Hc:xxxx Specify app heap commit size
# -Txx    Specify output file type  -S:xxxx  Specify app stack reserve size
#         -Tpx  PE image            -Sc:xxxx Specify app stack commit size
#         (x: e=EXE, d=DLL, p=BPL)  -Af:nnnn Specify file alignment
# -ax     Specify application type  -Ao:nnnn Specify object alignment
#         -ap Windowing Compatible  -C       Clear state before linking
#         -aa Uses Windowing API    -Vd.d    Specify Windows version
# --------------------------------------------------------------- 
!if !$d(BCB)
BCB = $(MAKEDIR)\..
!endif

# Define a name for the executable
PROJECT = testprog

# Setup additional paths for includes and source code
PLACENEW_PATH = 

ADD_INC_PATHS = -I../../include

# Setup define macros
DEFMACS = -D__BCC_BUILDER_40__ 

# Define macros for compiler and linker
CC = bcc32
CPP = bcc32
LINKER = ilink32

# BCC 32 flags need to build console applications
SYSDEFINES = _NO_VCL
CFLAG1 = -I$(BCB)\include -Od -w -Tkh30000 -r- -a8 -k -y -v -vi- -c -tWM -tWC \
-D$(SYSDEFINES);$(USERDEFINES) 
LFLAG1 = -L$(BCB)\lib;$(DEBUGLIBPATH) -ap -Tpe -x -Gn -v

# Define compiler and linker flags macros
CFLAGS= $(CFLAG1) $(ADD_INC_PATHS) $(DEFMACS)
COMPILE_ONLY = /c
LFLAGS = $(LFLAG1)

# Build dependency rules
# ===============================================================
TESTPROG_DEP = ../../include/placenew.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT).exe

testprog.obj:	testprog.cpp $(TESTPROG_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testprog.cpp

# Make the executable
OBJS = testprog.obj 

# BCC 32 libs needed to build console applications
ALLOBJ = c0x32.obj $(OBJS)
ALLRES = $(RESFILES)
ALLLIB = $(LIBFILES) import32.lib cw32mt.lib

$(PROJECT).exe:	$(OBJS)
	$(LINKER) @&&!
	$(LFLAGS) +
	$(ALLOBJ), +
	$(PROJECT),, +
	$(ALLLIB), +
	$(DEFFILE), +
	$(ALLRES)
!
# ===============================================================

# Remove OBJS, debug files, and executable after running nmake 
# ===============================================================
clean:
	@echo Removing all .tds files from working directory...
	if exist *.tds del *.tds 

	@echo Removing all .ils files from working directory...
	if exist *.ils del *.ils 

	@echo Removing all .ilf files from working directory...
	if exist *.ilf del *.ilf 

	@echo Removing all .ilc files from working directory...
	if exist *.ilc del *.ilc 

	@echo Removing all .ild files from working directory...
	if exist *.ild del *.ild 

	@echo Removing all .map files from working directory...
	if exist *.map del *.map 

	@echo Removing all .OBJ files from working directory...
	if exist *.obj del *.obj 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT).exe del $(PROJECT).exe 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################

