#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program  
# C/C++ Compiler Used: Borland C++ Builder 4.0
# Produced By: Doug Gaer
# File Creation Date: 08/05/1999 
# Date Last Modified: 09/02/1999
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#
# --------------------------------------------------------------- 
!if !$d(BCB)
BCB = $(MAKEDIR)\..
!endif

# Define a name for the executable
PROJECT = testprog

# Setup additional paths for includes and source code
RBTREE_PATH = ../../src/
QUEUE_PATH = ../../src/
SLLISTB_PATH = ../../src/
STACK_PATH = ../../src/
USTRING_PATH = ../../src/

ADD_INC_PATHS = -I../../include

# Setup define macros
DEFMACS = -D__BCC_BUILDER_40__ -D__DOS__ 

# Define macros for compiler and linker
CC = bcc32
CPP = bcc32
LINKER = ilink32

# BCC 32 flags need to build console applications
SYSDEFINES = _NO_VCL
CFLAG1 = -I$(BCB)\include -Od -w -Tkh30000 -r- -a8 -k -y -v -vi- -c -tWM -tWC \
-D$(SYSDEFINES);$(USERDEFINES) 
LFLAG1 = -L$(BCB)\lib;$(DEBUGLIBPATH) -ap -Tpe -x -Gn -v

# Define compiler and linker flags macros
CFLAGS= $(CFLAG1) $(ADD_INC_PATHS) $(DEFMACS)
COMPILE_ONLY = /c
LFLAGS = $(LFLAG1)

# Build dependency rules
# ===============================================================
BNODEB_DEP = ../../include/bnodeb.h ../../include/queue.h \
	../../include/sllist.h ../../include/sllistb.h \
	../../include/stack.h

BSTREEB_DEP = ../../include/bnode.h ../../include/bnodeb.h \
	../../include/bstreeb.h

RBTREEB_DEP = ../../include/bnode.h ../../include/bnodeb.h \
	../../include/bstreeb.h ../../include/queue.h \
	../../include/rbnode.h ../../include/rbtree.h \
	../../include/rbtreeb.h ../../include/sllist.h \
	../../include/sllistb.h ../../include/stack.h \
	../../include/twalk.h

SLLISTB_DEP = ../../include/sllistb.h

TESTPROG_DEP = ../../include/bnode.h ../../include/bnodeb.h \
	../../include/bstreeb.h ../../include/queue.h \
	../../include/rbnode.h ../../include/rbtree.h \
	../../include/rbtreeb.h ../../include/sllist.h \
	../../include/sllistb.h ../../include/stack.h \
	../../include/treeprt.h ../../include/twalk.h \
	../../include/ustring.h

TREEPRT_DEP = ../../include/bnode.h ../../include/bnodeb.h \
	../../include/queue.h ../../include/rbnode.h \
	../../include/sllist.h ../../include/sllistb.h \
	../../include/stack.h ../../include/treeprt.h \
	../../include/twalk.h

TWALK_DEP = ../../include/bnode.h ../../include/bnodeb.h \
	../../include/queue.h ../../include/rbnode.h \
	../../include/sllist.h ../../include/sllistb.h \
	../../include/stack.h ../../include/twalk.h

USTRING_DEP = ../../include/ustring.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT).exe

bnodeb.obj:	$(RBTREE_PATH)bnodeb.cpp $(BNODEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(RBTREE_PATH)bnodeb.cpp

bstreeb.obj:	$(RBTREE_PATH)bstreeb.cpp $(BSTREEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(RBTREE_PATH)bstreeb.cpp

rbtreeb.obj:	$(RBTREE_PATH)rbtreeb.cpp $(RBTREEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(RBTREE_PATH)rbtreeb.cpp

sllistb.obj:	$(SLLISTB_PATH)sllistb.cpp $(SLLISTB_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(SLLISTB_PATH)sllistb.cpp

testprog.obj:	testprog.cpp $(TESTPROG_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) testprog.cpp

treeprt.obj:	$(RBTREE_PATH)treeprt.cpp $(TREEPRT_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(RBTREE_PATH)treeprt.cpp

twalk.obj:	$(RBTREE_PATH)twalk.cpp $(TWALK_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(RBTREE_PATH)twalk.cpp

ustring.obj:	$(USTRING_PATH)ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(CFLAGS) $(USTRING_PATH)ustring.cpp

# Make the executable
OBJS = bnodeb.obj bstreeb.obj rbtreeb.obj sllistb.obj \
	treeprt.obj twalk.obj ustring.obj testprog.obj

# BCC 32 libs needed to build console applications
ALLOBJ = c0x32.obj $(OBJS)
ALLRES = $(RESFILES)
ALLLIB = $(LIBFILES) import32.lib cw32mt.lib

$(PROJECT).exe:	$(OBJS)
	$(LINKER) @&&!
	$(LFLAGS) +
	$(ALLOBJ), +
	$(PROJECT),, +
	$(ALLLIB), +
	$(DEFFILE), +
	$(ALLRES)
!
# ===============================================================

# Remove OBJS, debug files, and executable after running nmake 
# ===============================================================
clean:
	@echo Removing all .tds files from working directory...
	if exist *.tds del *.tds 

	@echo Removing all .ils files from working directory...
	if exist *.ils del *.ils 

	@echo Removing all .ilf files from working directory...
	if exist *.ilf del *.ilf 

	@echo Removing all .ilc files from working directory...
	if exist *.ilc del *.ilc 

	@echo Removing all .ild files from working directory...
	if exist *.ild del *.ild 

	@echo Removing all .map files from working directory...
	if exist *.map del *.map 

	@echo Removing all .OBJ files from working directory...
	if exist *.obj del *.obj 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT).exe del $(PROJECT).exe 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################


