// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: navtypes.h 
// Compiler Used: MSVC40, DJGPP 2.7.2.1, GCC 2.7.2.1, HP CPP 10.24
// Produced By: Doug Gaer   
// File Creation Date: 09/14/1999  
// Date Last Modified: 10/12/1999
// Copyright (c) 1997 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBD C++ classes are copyright (c) 1997, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

This include file is used to define the native types when
platform independent data types are disabled. When the 
__USE_NATIVE_INT_TYPES__ macro is defined, type defines will be
used for the INT32, UINT32, INT16, and UINT16 data types. When
the __USE_NATIVE_FLOAT_TYPES__ macro is defined, a type define
will be used in place of the FLOAT64 type. Additionally, the
INT32, UINT32, INT16, UINT16, and FLOAT64 data types can remain
undefined by using the __DO_NOT_DEFINE_INT_TYPES__ or the
__DO_NOT_DEFINE_FLOAT_TYPES__ macro. This will prevent conflicts
when the data type is already defined by another API.

Changes: 
============================================================
10/10/1999: - Added __WIN32__ macro to the MSVC Win32 project
compile.
Added by: Milos Jevtic

10/11/1999 - Added __MFC__ macro to work with the MFC library.
Added by: Oleg Smolsky
*/
// ----------------------------------------------------------- //   
#ifndef __NAVTYPES_HPP__
#define __NAVTYPES_HPP__

#ifndef __DO_NOT_DEFINE_INT_TYPES__

#if defined (__MFC__)  // By Oleg: put conditional MFC include
#define VC_EXTRALEAN
#include <afxwin.h>
typedef short INT16;
typedef unsigned short UINT16;

#elif defined (__WIN32__)
#include <basetsd.h>
typedef short INT16;
typedef unsigned short UINT16;

#else
typedef long INT32;
typedef unsigned long UINT32;
typedef short INT16;
typedef unsigned short UINT16;
#endif // MFC and WIN32 directives

#endif // __DO_NOT_DEFINE_INT_TYPES__

#ifndef __DO_NOT_DEFINE_FLOAT_TYPES__
typedef double FLOAT64;
#endif // __DO_NOT_DEFINE_FLOAT_TYPES__

#endif // __NAVTYPES_HPP__
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
